QuantLib: InterpolatedSurvivalProbabilityCurve< Interpolator > Class Template Reference

A free/open-source library for quantitative finance Reference manual - version 1.6

- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
InterpolatedSurvivalProbabilityCurve< Interpolator > Class Template Reference

DefaultProbabilityTermStructure based on interpolation of survival probabilities. More...

`#include <ql/termstructures/credit/interpolatedsurvivalprobabilitycurve.hpp>`

Inheritance diagram for InterpolatedSurvivalProbabilityCurve< Interpolator >:
[legend]

## Public Member Functions
| InterpolatedSurvivalProbabilityCurve (const std::vector< Date > &dates, const std::vector< Probability > &probabilities, const DayCounter &dayCounter, const Calendar &calendar=Calendar(), const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >(), const Interpolator &interpolator=Interpolator())
TermStructure interface
Date | maxDate () const
| the latest date for which the curve can return values
other inspectors
const std::vector< Time > & | times () const
const std::vector< Date > & | dates () const
const std::vector< Real > & | data () const
const std::vector< Probability > & | survivalProbabilities () const
std::vector< std::pair< Date, Real > > | nodes () const
Public Member Functions inherited from SurvivalProbabilityStructure
| SurvivalProbabilityStructure (const DayCounter &dayCounter=DayCounter(), const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >())
| SurvivalProbabilityStructure (const Date &referenceDate, const Calendar &cal=Calendar(), const DayCounter &dayCounter=DayCounter(), const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >())
| SurvivalProbabilityStructure (Natural settlementDays, const Calendar &cal, const DayCounter &dayCounter=DayCounter(), const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >())
Public Member Functions inherited from DefaultProbabilityTermStructure
| DefaultProbabilityTermStructure (const DayCounter &dc=DayCounter(), const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >())
| DefaultProbabilityTermStructure (const Date &referenceDate, const Calendar &cal=Calendar(), const DayCounter &dc=DayCounter(), const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >())
| DefaultProbabilityTermStructure (Natural settlementDays, const Calendar &cal, const DayCounter &dc=DayCounter(), const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >())
Probability | survivalProbability (const Date &d, bool extrapolate=false) const
Probability | survivalProbability (Time t, bool extrapolate=false) const
Probability | defaultProbability (const Date &d, bool extrapolate=false) const
Probability | defaultProbability (Time t, bool extrapolate=false) const
Probability | defaultProbability (const Date &, const Date &, bool extrapolate=false) const
| probability of default between two given dates
Probability | defaultProbability (Time, Time, bool extrapo=false) const
| probability of default between two given times
Real | defaultDensity (const Date &d, bool extrapolate=false) const
Real | defaultDensity (Time t, bool extrapolate=false) const
Rate | hazardRate (const Date &d, bool extrapolate=false) const
Rate | hazardRate (Time t, bool extrapolate=false) const
const std::vector< Date > & | jumpDates () const
const std::vector< Time > & | jumpTimes () const
void | update ()
Public Member Functions inherited from TermStructure
| TermStructure (const DayCounter &dc=DayCounter())
| default constructor More...
| TermStructure (const Date &referenceDate, const Calendar &calendar=Calendar(), const DayCounter &dc=DayCounter())
| initialize with a fixed reference date
| TermStructure (Natural settlementDays, const Calendar &, const DayCounter &dc=DayCounter())
| calculate the reference date based on the global evaluation date
virtual DayCounter | dayCounter () const
| the day counter used for date/time conversion
Time | timeFromReference (const Date &date) const
| date/time conversion
virtual Time | maxTime () const
| the latest time for which the curve can return values
virtual const Date & | referenceDate () const
| the date at which discount = 1.0 and/or variance = 0.0
virtual Calendar | calendar () const
| the calendar used for reference and/or option date calculation
virtual Natural | settlementDays () const
| the settlementDays used for reference date calculation
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< std::set< boost::shared_ptr< Observable > >::iterator, bool > | registerWith (const boost::shared_ptr< Observable > &)
void | registerWithObservables (const boost::shared_ptr< Observer > &)
Size | unregisterWith (const boost::shared_ptr< Observable > &)
void | unregisterWithAll ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()
Public Member Functions inherited from Extrapolator
void | enableExtrapolation (bool b=true)
| enable extrapolation in subsequent calls
void | disableExtrapolation (bool b=true)
| disable extrapolation in subsequent calls
bool | allowsExtrapolation () const
| tells whether extrapolation is enabled

## Protected Member Functions
| InterpolatedSurvivalProbabilityCurve (const DayCounter &, const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >(), const Interpolator &interpolator=Interpolator())
| InterpolatedSurvivalProbabilityCurve (const Date &referenceDate, const DayCounter &, const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >(), const Interpolator &interpolator=Interpolator())
| InterpolatedSurvivalProbabilityCurve (Natural settlementDays, const Calendar &, const DayCounter &, const std::vector< Handle< Quote > > &jumps=std::vector< Handle< Quote > >(), const std::vector< Date > &jumpDates=std::vector< Date >(), const Interpolator &interpolator=Interpolator())
DefaultProbabilityTermStructure implementation
Probability | survivalProbabilityImpl (Time) const
| survival probability calculation
Real | defaultDensityImpl (Time) const
| default density calculation
Protected Member Functions inherited from SurvivalProbabilityStructure
Real | defaultDensityImpl (Time) const
| instantaneous default density at a given time More...
Calculations
These methods must be implemented in derived classes to perform the actual calculations. When they are called, range check has already been performed; therefore, they must assume that extrapolation is required.
Protected Member Functions inherited from TermStructure
void | checkRange (const Date &d, bool extrapolate) const
| date-range check
void | checkRange (Time t, bool extrapolate) const
| time-range check
Protected Member Functions inherited from InterpolatedCurve< Interpolator >
void | setupInterpolation ()
| InterpolatedCurve (const std::vector< Time > &times, const std::vector< Real > &data, const Interpolator &i=Interpolator())
| InterpolatedCurve (const std::vector< Time > &times, const Interpolator &i=Interpolator())
| InterpolatedCurve (Size n, const Interpolator &i=Interpolator())
| InterpolatedCurve (const Interpolator &i=Interpolator())
| InterpolatedCurve (const InterpolatedCurve &c)
InterpolatedCurve & | operator= (const InterpolatedCurve &c)

## Protected Attributes
std::vector< Date > | dates_
Protected Attributes inherited from TermStructure
bool | moving_
bool | updated_
Calendar | calendar_
Protected Attributes inherited from InterpolatedCurve< Interpolator >
std::vector< Time > | times_
std::vector< Real > | data_
Interpolation | interpolation_
Interpolator | interpolator_

## Detailed Description

### template<class Interpolator>
class QuantLib::InterpolatedSurvivalProbabilityCurve< Interpolator >

DefaultProbabilityTermStructure based on interpolation of survival probabilities.